/* A Bison parser, made by GNU Bison 3.5.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "mpsl.y"

/*

    MPSL - Minimum Profit Scripting Language
    YACC parser

    Angel Ortega <angel@triptico.com> et al.

    This software is released into the public domain.
    NO WARRANTY. See file LICENSE for details.

*/

#include <stdio.h>
#include <string.h>
#include <wchar.h>
#include <stdlib.h>
#include "mpdm.h"
#include "mpsl.h"

#define COMPILER_VERSION "1.01"

/** data **/

/* the bytecode being generated */
static mpdm_t mpsl_bytecode = NULL;

/* pointer to source code being compiled */
extern wchar_t *mpsl_next_char;

/* pointer to file being compiled */
extern FILE *mpsl_file;

/* line number */
extern int mpsl_line;

/* compilation source */
mpdm_t mpsl_source = NULL;

/* cached value MPSL.LC */
extern mpdm_t mpsl_lc;


/** code **/

int yylex(void);
void yyerror(char *s);

#define INS0(o)             mpsl_mkins(o, 0, NULL, NULL, NULL, NULL)
#define INS1(o,a1)          mpsl_mkins(o, 1, a1, NULL, NULL, NULL)
#define INS2(o,a1,a2)       mpsl_mkins(o, 2, a1, a2, NULL, NULL)
#define INS3(o,a1,a2,a3)    mpsl_mkins(o, 3, a1, a2, a3, NULL)
#define INS4(o,a1,a2,a3,a4) mpsl_mkins(o, 4, a1, a2, a3, a4)


#if 0
static void compiler_warning(char *str)
{
    fprintf(stderr, "WARNING: %s.\n", str);
}
#endif


static mpdm_t code_pos(void)
{
    char tmp[1024];

    sprintf(tmp, ":%d", mpsl_line + 1);

    return INS1(L"LITERAL", mpdm_strcat(mpsl_source, MPDM_MBS(tmp)));
}



#line 145 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    NULLV = 258,
    VER = 259,
    INTEGER = 260,
    REAL = 261,
    STRING = 262,
    SYMBOL = 263,
    LITERAL = 264,
    WHILE = 265,
    FOR = 266,
    IF = 267,
    SUB = 268,
    FOREACH = 269,
    LOCAL = 270,
    GLOBAL = 271,
    BREAK = 272,
    RETURN = 273,
    IFI = 274,
    ELSE = 275,
    AND = 276,
    OR = 277,
    IADD = 278,
    ISUB = 279,
    IMUL = 280,
    IDIV = 281,
    IMOD = 282,
    ORASSIGN = 283,
    EQ = 284,
    NE = 285,
    GE = 286,
    LE = 287,
    ARROW = 288,
    MOD = 289,
    INVCALL = 290,
    UMINUS = 291
  };
#endif
/* Tokens.  */
#define NULLV 258
#define VER 259
#define INTEGER 260
#define REAL 261
#define STRING 262
#define SYMBOL 263
#define LITERAL 264
#define WHILE 265
#define FOR 266
#define IF 267
#define SUB 268
#define FOREACH 269
#define LOCAL 270
#define GLOBAL 271
#define BREAK 272
#define RETURN 273
#define IFI 274
#define ELSE 275
#define AND 276
#define OR 277
#define IADD 278
#define ISUB 279
#define IMUL 280
#define IDIV 281
#define IMOD 282
#define ORASSIGN 283
#define EQ 284
#define NE 285
#define GE 286
#define LE 287
#define ARROW 288
#define MOD 289
#define INVCALL 290
#define UMINUS 291

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 76 "mpsl.y"

    mpdm_t v;   /* a simple value */
    mpdm_t ins; /* an 'instruction': [ opcode, args ] */

#line 274 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */



#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1184

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  56
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  10
/* YYNRULES -- Number of rules.  */
#define YYNRULES  78
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  195

#define YYUNDEFTOK  2
#define YYMAXUTOK   291


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    29,     2,     2,    44,     2,     2,     2,
      47,    48,    40,    38,    51,    39,    53,    41,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    35,    46,
      37,    52,    36,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    54,     2,    55,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    49,     2,    50,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    30,    31,    32,    33,    34,    42,
      43,    45
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   101,   101,   105,   108,   112,   116,   121,   126,   131,
     136,   141,   147,   156,   166,   175,   188,   204,   210,   214,
     225,   229,   240,   244,   248,   255,   256,   263,   266,   274,
     278,   286,   289,   292,   298,   307,   311,   316,   321,   328,
     332,   336,   340,   344,   348,   353,   359,   360,   361,   362,
     363,   365,   368,   374,   380,   386,   392,   399,   406,   410,
     414,   418,   422,   426,   430,   436,   440,   445,   450,   456,
     461,   465,   470,   474,   479,   483,   487,   491,   495
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NULLV", "VER", "INTEGER", "REAL",
  "STRING", "SYMBOL", "LITERAL", "WHILE", "FOR", "IF", "SUB", "FOREACH",
  "LOCAL", "GLOBAL", "BREAK", "RETURN", "IFI", "ELSE", "AND", "OR", "IADD",
  "ISUB", "IMUL", "IDIV", "IMOD", "ORASSIGN", "'!'", "EQ", "NE", "GE",
  "LE", "ARROW", "':'", "'>'", "'<'", "'+'", "'-'", "'*'", "'/'", "MOD",
  "INVCALL", "'$'", "UMINUS", "';'", "'('", "')'", "'{'", "'}'", "','",
  "'='", "'.'", "'['", "']'", "$accept", "program", "function", "stmt",
  "stmt_list", "list", "sym_list", "hash", "compsym", "expr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,    33,
     284,   285,   286,   287,   288,    58,    62,    60,    43,    45,
      42,    47,   289,   290,    36,   291,    59,    40,    41,   123,
     125,    44,    61,    46,    91,    93
};
# endif

#define YYPACT_NINF (-63)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -63,     2,   555,   -63,   -63,   -63,   -63,   -63,   -63,   -63,
     -25,   -12,    28,    -5,    43,    57,    86,    62,   574,   703,
     703,   -63,   703,   191,   138,   -63,   555,   711,   936,   703,
     585,   703,   105,   555,     1,   115,   100,   -20,   103,    -8,
     -63,    17,   -63,   637,   962,   -24,   -63,   766,   122,   -63,
     243,    78,   910,   -63,   -28,  1140,   -63,   703,   703,   703,
     703,   703,   703,   649,   703,    97,   703,   703,   703,   703,
     703,   703,   703,   703,   703,   703,   703,   703,   703,   703,
     115,   703,   -63,   790,    84,   988,   814,   -63,    59,   295,
      -3,   555,    -2,   703,   -63,   150,   703,   -63,  1092,   -63,
     -63,   703,   -63,   -63,   720,   703,   703,   -63,   -24,   -24,
     -24,   -24,   -24,   -24,   -63,    70,  1140,   -63,   -63,   740,
     -24,   -24,    18,    18,    18,    18,    18,    18,    92,    92,
      95,    95,    95,   -43,   -63,   555,   111,   703,   555,   113,
     -63,   114,    71,   347,   703,  1014,   -63,  1040,  1140,   125,
    1116,  1140,  1140,   -63,   -63,   666,   -63,   555,  1066,   148,
     555,   555,   120,   -63,    73,   838,   -63,   -63,   703,   703,
     -63,    89,   -63,   703,   555,   399,   451,   555,   703,   555,
    1140,  1140,   -63,   862,   -63,   -63,   -63,   503,   886,   -63,
     555,   -63,   555,   -63,   -63
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       4,     0,     2,     1,    43,    44,    39,    41,    40,    35,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     5,     0,     0,     0,    25,     3,    42,     0,     0,
       0,     0,     0,     0,     0,     0,    29,     0,    29,     0,
      22,     0,    24,     0,     0,    58,    45,     0,    35,    72,
       0,     0,     0,    70,     0,    27,    26,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     6,     0,     0,     0,     0,    29,     0,     0,
       0,     0,     0,     0,    18,     0,     0,    20,     0,    23,
      69,     0,    17,    73,     0,     0,     0,    71,    52,    53,
      54,    55,    56,    57,    74,     0,    78,    36,    37,     0,
      65,    66,    63,    64,    62,    61,    60,    59,    46,    47,
      48,    49,    50,     0,    51,     0,     0,     0,     0,     0,
      67,     0,     0,     0,     0,     0,    30,     0,    32,    35,
       0,    31,    28,    75,    38,     0,     7,     0,     0,    10,
       0,     0,     0,    12,    42,     0,    19,    21,     0,     0,
      76,     0,     9,     0,     0,     0,     0,     0,     0,     0,
      34,    33,    77,     0,    11,    68,    13,     0,     0,    15,
       0,    14,     0,     8,    16
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -63,   -63,   -63,   -26,    13,   -62,     5,   -63,    12,    10
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     2,    25,    26,    54,    37,    51,    27,    28
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      56,   115,     3,     9,   155,    87,    69,    70,    71,    72,
      65,    66,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    39,    29,   106,    56,    34,    94,   107,    44,    45,
      46,    95,    47,    52,    55,    30,    50,    88,    97,    83,
      85,    86,    32,    95,    33,   141,    89,    92,    90,   144,
      91,    65,    66,    98,    65,    66,    75,    76,    77,    78,
      79,    80,    81,    56,    32,    36,    33,   108,   109,   110,
     111,   112,   113,    55,   116,    31,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
      35,   134,   133,   171,    38,   142,    57,    58,    59,    60,
      61,    62,   117,   145,   143,   118,   147,   139,    40,   156,
      95,   148,   159,    87,   150,   151,   152,    56,   153,   162,
      63,   106,    95,     9,   178,    64,    65,    66,   103,   104,
     136,   172,    77,    78,    79,    80,    81,   182,    80,    81,
     106,     4,     5,     6,     7,     8,     9,   158,   184,    56,
      56,    41,    93,   189,   165,    96,   164,   101,   146,   157,
     168,    56,   160,   161,   193,    55,   194,    19,   174,   177,
       0,     0,     0,   175,   176,     0,     0,    20,   180,   181,
       0,     0,     0,   183,     0,    22,     0,    43,   188,     0,
     187,     0,    24,    53,     4,     5,     6,     7,     8,    48,
       0,    10,    11,    12,    13,    14,    15,    16,    17,    18,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      19,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,     0,     0,     0,     0,    21,    22,     0,
      23,    49,     0,     0,     0,    24,     4,     5,     6,     7,
       8,     9,     0,    10,    11,    12,    13,    14,    15,    16,
      17,    18,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    19,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    20,     0,     0,     0,     0,     0,     0,    21,
      22,     0,    23,   102,     0,     0,     0,    24,     4,     5,
       6,     7,     8,     9,     0,    10,    11,    12,    13,    14,
      15,    16,    17,    18,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    19,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    20,     0,     0,     0,     0,     0,
       0,    21,    22,     0,    23,   140,     0,     0,     0,    24,
       4,     5,     6,     7,     8,     9,     0,    10,    11,    12,
      13,    14,    15,    16,    17,    18,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    19,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    20,     0,     0,     0,
       0,     0,     0,    21,    22,     0,    23,   163,     0,     0,
       0,    24,     4,     5,     6,     7,     8,     9,     0,    10,
      11,    12,    13,    14,    15,    16,    17,    18,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    19,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,     0,     0,     0,     0,    21,    22,     0,    23,   185,
       0,     0,     0,    24,     4,     5,     6,     7,     8,     9,
       0,    10,    11,    12,    13,    14,    15,    16,    17,    18,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      19,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,     0,     0,     0,     0,    21,    22,     0,
      23,   186,     0,     0,     0,    24,     4,     5,     6,     7,
       8,     9,     0,    10,    11,    12,    13,    14,    15,    16,
      17,    18,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    19,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    20,     0,     0,     0,     0,     0,     0,    21,
      22,     0,    23,   191,     0,     0,     0,    24,     4,     5,
       6,     7,     8,     9,     0,    10,    11,    12,    13,    14,
      15,    16,    17,    18,     0,     0,     0,     4,     5,     6,
       7,     8,     9,     0,    19,     0,     0,    41,     4,     5,
       6,     7,     8,     9,    20,     0,     0,     0,    41,     0,
       0,    21,    22,    19,    23,     0,     0,     0,     0,    24,
       0,     0,     0,    20,    19,     0,     0,     0,     0,     0,
      42,    22,     0,    43,    20,     0,     0,     0,    24,     0,
       0,    84,    22,     0,    43,     0,     0,     0,     0,    24,
       4,     5,     6,     7,     8,    48,     0,     0,     0,     0,
      41,     0,     4,     5,     6,     7,     8,     9,     0,     0,
       0,     0,    41,     0,     0,     0,    19,     0,     0,     4,
       5,     6,     7,     8,     9,     0,    20,     0,    19,    41,
       0,     0,     0,     0,    22,     0,    43,    49,    20,     0,
       0,    24,     0,     0,     0,    19,    22,   114,    43,     0,
       0,     0,     0,    24,     0,    20,     4,     5,     6,     7,
       8,     9,     0,    22,   170,    43,    41,     0,     0,     0,
      24,     0,     0,     4,     5,     6,     7,     8,   149,     0,
       0,     0,    19,    41,    57,    58,    59,    60,    61,    62,
       0,     0,    20,     0,     0,     0,     0,     0,     0,    19,
      22,     0,    43,     0,     0,     0,     0,    24,    63,    20,
       0,    67,    68,    64,    65,    66,     0,    22,     0,    43,
      69,    70,    71,    72,    24,     0,    73,    74,    75,    76,
      77,    78,    79,    80,    81,     0,     0,    67,    68,     0,
       0,     0,     0,     0,     0,   154,    69,    70,    71,    72,
       0,     0,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    67,    68,     0,   100,     0,     0,     0,     0,     0,
      69,    70,    71,    72,     0,     0,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    67,    68,     0,   135,     0,
       0,     0,     0,     0,    69,    70,    71,    72,     0,     0,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    67,
      68,     0,   138,     0,     0,     0,     0,     0,    69,    70,
      71,    72,     0,     0,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    67,    68,     0,   179,     0,     0,     0,
       0,     0,    69,    70,    71,    72,     0,     0,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    67,    68,     0,
     190,     0,     0,     0,     0,     0,    69,    70,    71,    72,
       0,     0,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    67,    68,     0,   192,     0,     0,     0,     0,     0,
      69,    70,    71,    72,   105,     0,    73,    74,    75,    76,
      77,    78,    79,    80,    81,     0,    82,    67,    68,     0,
       0,     0,     0,     0,     0,     0,    69,    70,    71,    72,
       0,     0,    73,    74,    75,    76,    77,    78,    79,    80,
      81,     0,    82,    67,    68,     0,     0,     0,     0,     0,
       0,     0,    69,    70,    71,    72,     0,     0,    73,    74,
      75,    76,    77,    78,    79,    80,    81,     0,    99,    67,
      68,     0,     0,     0,     0,     0,     0,     0,    69,    70,
      71,    72,     0,     0,    73,    74,    75,    76,    77,    78,
      79,    80,    81,     0,   137,    67,    68,     0,     0,     0,
       0,     0,     0,     0,    69,    70,    71,    72,     0,     0,
      73,    74,    75,    76,    77,    78,    79,    80,    81,     0,
     166,    67,    68,     0,     0,     0,     0,     0,     0,     0,
      69,    70,    71,    72,     0,     0,    73,    74,    75,    76,
      77,    78,    79,    80,    81,     0,   167,    67,    68,     0,
       0,     0,     0,     0,     0,     0,    69,    70,    71,    72,
       0,     0,    73,    74,    75,    76,    77,    78,    79,    80,
      81,     0,   173,    67,    68,     0,     0,     0,     0,     0,
       0,     0,    69,    70,    71,    72,   105,     0,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    67,    68,     0,
       0,     0,     0,     0,     0,     0,    69,    70,    71,    72,
     169,     0,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    67,    68,     0,     0,     0,     0,     0,     0,     0,
      69,    70,    71,    72,     0,     0,    73,    74,    75,    76,
      77,    78,    79,    80,    81
};

static const yytype_int16 yycheck[] =
{
      26,    63,     0,     8,    47,     8,    30,    31,    32,    33,
      53,    54,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    16,    47,    51,    50,    13,    46,    55,    18,    19,
      20,    51,    22,    23,    24,    47,    23,    32,    46,    29,
      30,    31,    47,    51,    49,    48,    33,    35,    47,    51,
      49,    53,    54,    43,    53,    54,    38,    39,    40,    41,
      42,    43,    44,    89,    47,     8,    49,    57,    58,    59,
      60,    61,    62,    63,    64,    47,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      47,    81,    80,   155,     8,    90,    23,    24,    25,    26,
      27,    28,     5,    93,    91,     8,    96,    48,    46,   135,
      51,   101,   138,     8,   104,   105,   106,   143,    48,    48,
      47,    51,    51,     8,    51,    52,    53,    54,    50,    51,
      46,   157,    40,    41,    42,    43,    44,    48,    43,    44,
      51,     3,     4,     5,     6,     7,     8,   137,   174,   175,
     176,    13,    52,   179,   144,    52,   144,    35,     8,    48,
      35,   187,    49,    49,   190,   155,   192,    29,    20,    49,
      -1,    -1,    -1,   160,   161,    -1,    -1,    39,   168,   169,
      -1,    -1,    -1,   173,    -1,    47,    -1,    49,   178,    -1,
     177,    -1,    54,    55,     3,     4,     5,     6,     7,     8,
      -1,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    46,    47,    -1,
      49,    50,    -1,    -1,    -1,    54,     3,     4,     5,     6,
       7,     8,    -1,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      47,    -1,    49,    50,    -1,    -1,    -1,    54,     3,     4,
       5,     6,     7,     8,    -1,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    46,    47,    -1,    49,    50,    -1,    -1,    -1,    54,
       3,     4,     5,     6,     7,     8,    -1,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    46,    47,    -1,    49,    50,    -1,    -1,
      -1,    54,     3,     4,     5,     6,     7,     8,    -1,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    47,    -1,    49,    50,
      -1,    -1,    -1,    54,     3,     4,     5,     6,     7,     8,
      -1,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    46,    47,    -1,
      49,    50,    -1,    -1,    -1,    54,     3,     4,     5,     6,
       7,     8,    -1,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      47,    -1,    49,    50,    -1,    -1,    -1,    54,     3,     4,
       5,     6,     7,     8,    -1,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,    -1,    29,    -1,    -1,    13,     3,     4,
       5,     6,     7,     8,    39,    -1,    -1,    -1,    13,    -1,
      -1,    46,    47,    29,    49,    -1,    -1,    -1,    -1,    54,
      -1,    -1,    -1,    39,    29,    -1,    -1,    -1,    -1,    -1,
      46,    47,    -1,    49,    39,    -1,    -1,    -1,    54,    -1,
      -1,    46,    47,    -1,    49,    -1,    -1,    -1,    -1,    54,
       3,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
      13,    -1,     3,     4,     5,     6,     7,     8,    -1,    -1,
      -1,    -1,    13,    -1,    -1,    -1,    29,    -1,    -1,     3,
       4,     5,     6,     7,     8,    -1,    39,    -1,    29,    13,
      -1,    -1,    -1,    -1,    47,    -1,    49,    50,    39,    -1,
      -1,    54,    -1,    -1,    -1,    29,    47,    48,    49,    -1,
      -1,    -1,    -1,    54,    -1,    39,     3,     4,     5,     6,
       7,     8,    -1,    47,    48,    49,    13,    -1,    -1,    -1,
      54,    -1,    -1,     3,     4,     5,     6,     7,     8,    -1,
      -1,    -1,    29,    13,    23,    24,    25,    26,    27,    28,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    29,
      47,    -1,    49,    -1,    -1,    -1,    -1,    54,    47,    39,
      -1,    21,    22,    52,    53,    54,    -1,    47,    -1,    49,
      30,    31,    32,    33,    54,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    -1,    -1,    21,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    21,    22,    -1,    48,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    21,    22,    -1,    48,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    21,
      22,    -1,    48,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    21,    22,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    21,    22,    -1,
      48,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    21,    22,    -1,    48,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    -1,    46,    21,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    -1,    46,    21,    22,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    -1,    46,    21,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    -1,    46,    21,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    -1,
      46,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    -1,    46,    21,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    -1,    46,    21,    22,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    21,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    57,    58,     0,     3,     4,     5,     6,     7,     8,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    29,
      39,    46,    47,    49,    54,    59,    60,    64,    65,    47,
      47,    47,    47,    49,    64,    47,     8,    62,     8,    62,
      46,    13,    46,    49,    65,    65,    65,    65,     8,    50,
      60,    63,    65,    55,    61,    65,    59,    23,    24,    25,
      26,    27,    28,    47,    52,    53,    54,    21,    22,    30,
      31,    32,    33,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    46,    65,    46,    65,    65,     8,    62,    60,
      47,    49,    64,    52,    46,    51,    52,    46,    65,    46,
      48,    35,    50,    50,    51,    34,    51,    55,    65,    65,
      65,    65,    65,    65,    48,    61,    65,     5,     8,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    64,    65,    48,    46,    46,    48,    48,
      50,    48,    62,    60,    51,    65,     8,    65,    65,     8,
      65,    65,    65,    48,    55,    47,    59,    48,    65,    59,
      49,    49,    48,    50,    64,    65,    46,    46,    35,    34,
      48,    61,    59,    46,    20,    60,    60,    49,    51,    48,
      65,    65,    48,    65,    59,    50,    50,    60,    65,    59,
      48,    50,    48,    59,    59
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    56,    57,    58,    58,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    60,    60,    61,    61,    62,
      62,    63,    63,    63,    63,    64,    64,    64,    64,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     0,     1,     2,     5,     9,     6,
       5,     7,     5,     7,     8,     7,     9,     3,     3,     5,
       3,     5,     2,     3,     2,     1,     2,     1,     3,     1,
       3,     3,     3,     5,     5,     1,     3,     3,     4,     1,
       1,     1,     1,     1,     1,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     4,     7,     3,
       2,     3,     2,     3,     3,     4,     5,     6,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[+yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[+*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYPTRDIFF_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2:
#line 101 "mpsl.y"
                    { ; }
#line 1765 "y.tab.c"
    break;

  case 3:
#line 105 "mpsl.y"
                        {
                    mpsl_bytecode = (yyvsp[0].ins);
                }
#line 1773 "y.tab.c"
    break;

  case 5:
#line 112 "mpsl.y"
                {
                    /* null instruction */
                    (yyval.ins) = INS0(L"MULTI");
                }
#line 1782 "y.tab.c"
    break;

  case 6:
#line 116 "mpsl.y"
                    {
                    /* expression, as is */
                    (yyval.ins) = (yyvsp[-1].ins);
                }
#line 1791 "y.tab.c"
    break;

  case 7:
#line 122 "mpsl.y"
                {
                    /* while loop */
                    (yyval.ins) = INS2(L"WHILE", (yyvsp[-2].ins), (yyvsp[0].ins));
                }
#line 1800 "y.tab.c"
    break;

  case 8:
#line 127 "mpsl.y"
                {
                    /* for loop */
                    (yyval.ins) = INS4(L"WHILE", (yyvsp[-4].ins), (yyvsp[0].ins), (yyvsp[-6].ins), (yyvsp[-2].ins));
                }
#line 1809 "y.tab.c"
    break;

  case 9:
#line 132 "mpsl.y"
                {
                    /* infinite loop */
                    (yyval.ins) = INS2(L"WHILE", INS1(L"LITERAL", mpdm_bool(1)), (yyvsp[0].ins));
                }
#line 1818 "y.tab.c"
    break;

  case 10:
#line 137 "mpsl.y"
                {
                    /* if - then construction */
                    (yyval.ins) = INS2(L"IF", (yyvsp[-2].ins), (yyvsp[0].ins));
                }
#line 1827 "y.tab.c"
    break;

  case 11:
#line 142 "mpsl.y"
                {
                    /* if - then - else construction */
                    (yyval.ins) = INS3(L"IF", (yyvsp[-4].ins), (yyvsp[-2].ins), (yyvsp[0].ins));
                }
#line 1836 "y.tab.c"
    break;

  case 12:
#line 148 "mpsl.y"
                {
                    /* subroutine definition,
                       without arguments */
                    (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-3].ins),
                        INS1(L"LITERAL",
                            mpsl_x((yyvsp[-1].ins), NULL, 1)));
                }
#line 1848 "y.tab.c"
    break;

  case 13:
#line 157 "mpsl.y"
                {
                    /* subroutine definition,
                       without arguments (second
                       syntax, including parens) */
                    (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-5].ins),
                        INS1(L"LITERAL",
                            mpsl_x((yyvsp[-1].ins), NULL, 1)));
                }
#line 1861 "y.tab.c"
    break;

  case 14:
#line 167 "mpsl.y"
                {
                    /* subroutine definition,
                       with arguments */
                    (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-6].ins),
                        INS1(L"LITERAL",
                            mpsl_x((yyvsp[-1].ins), (yyvsp[-4].ins), 1)));
                }
#line 1873 "y.tab.c"
    break;

  case 15:
#line 176 "mpsl.y"
                {
                    /* foreach (e, v) construction */
                    /* a block frame is created, the iterator
                       created as local, and the foreach executed */
                    (yyval.ins) = INS1(L"BLKFRAME",
                        INS2(L"MULTI",
                            INS1(L"LOCAL", (yyvsp[-4].ins)),
                            INS3(L"FOREACH", (yyvsp[-4].ins), (yyvsp[-2].ins), (yyvsp[0].ins))
                        )
                    );
                }
#line 1889 "y.tab.c"
    break;

  case 16:
#line 189 "mpsl.y"
                {
                    /* foreach (k, v, a) construction */
                    /* a block frame is created, the iterator
                       created as local, and the foreach executed */
                    (yyval.ins) = INS1(L"BLKFRAME",
                        INS2(L"MULTI",
                            INS1(L"LOCAL", (yyvsp[-6].ins)),
                            INS2(L"MULTI",
                                INS1(L"LOCAL", (yyvsp[-4].ins)),
                                INS4(L"FOREACH", (yyvsp[-6].ins), (yyvsp[-2].ins), (yyvsp[0].ins), (yyvsp[-4].ins))
                            )
                        )
                    );
                }
#line 1908 "y.tab.c"
    break;

  case 17:
#line 204 "mpsl.y"
                        {
                    /* block of instructions,
                       with local symbol table */
                    (yyval.ins) = INS1(L"BLKFRAME", (yyvsp[-1].ins));
                }
#line 1918 "y.tab.c"
    break;

  case 18:
#line 210 "mpsl.y"
                            {
                    /* local symbol creation */
                    (yyval.ins) = INS1(L"LOCAL", (yyvsp[-1].ins));
                }
#line 1927 "y.tab.c"
    break;

  case 19:
#line 215 "mpsl.y"
                {
                    /* contraction; local symbol
                       creation and assignation */
                    (yyval.ins) = INS2(L"MULTI",
                        INS1(L"LOCAL",
                            INS1(L"LITERAL", (yyvsp[-3].v))),
                        INS2(L"ASSIGN",
                            INS1(L"LITERAL", (yyvsp[-3].v)),(yyvsp[-1].ins))
                        );
                }
#line 1942 "y.tab.c"
    break;

  case 20:
#line 225 "mpsl.y"
                            {
                    /* global symbol creation */
                    (yyval.ins) = INS1(L"GLOBAL", (yyvsp[-1].ins));
                }
#line 1951 "y.tab.c"
    break;

  case 21:
#line 230 "mpsl.y"
                {
                    /* contraction; global symbol
                       creation and assignation */
                    (yyval.ins) = INS2(L"MULTI",
                        INS1(L"GLOBAL",
                            INS1(L"LITERAL", (yyvsp[-3].v))),
                        INS2(L"ASSIGN",
                            INS1(L"LITERAL", (yyvsp[-3].v)),(yyvsp[-1].ins))
                        );
                }
#line 1966 "y.tab.c"
    break;

  case 22:
#line 240 "mpsl.y"
                    {
                    /* break (exit from loop) */
                    (yyval.ins) = INS0(L"BREAK");
                }
#line 1975 "y.tab.c"
    break;

  case 23:
#line 244 "mpsl.y"
                        {
                    /* return from subroutine */
                    (yyval.ins) = INS1(L"RETURN", (yyvsp[-1].ins));
                }
#line 1984 "y.tab.c"
    break;

  case 24:
#line 248 "mpsl.y"
                        {
                    /* return from subroutine (void) */
                    (yyval.ins) = INS0(L"RETURN");
                }
#line 1993 "y.tab.c"
    break;

  case 25:
#line 255 "mpsl.y"
                    { (yyval.ins) = (yyvsp[0].ins); }
#line 1999 "y.tab.c"
    break;

  case 26:
#line 256 "mpsl.y"
                        {
                    /* sequence of instructions */
                    (yyval.ins) = INS2(L"MULTI", (yyvsp[-1].ins), (yyvsp[0].ins));
                }
#line 2008 "y.tab.c"
    break;

  case 27:
#line 263 "mpsl.y"
                    {
                    (yyval.ins) = INS1(L"LIST", (yyvsp[0].ins));
                }
#line 2016 "y.tab.c"
    break;

  case 28:
#line 266 "mpsl.y"
                        {
                    /* build list from list of
                       instructions */
                    (yyval.ins) = INS2(L"LIST", (yyvsp[0].ins), (yyvsp[-2].ins));
                }
#line 2026 "y.tab.c"
    break;

  case 29:
#line 274 "mpsl.y"
                    {
                    (yyval.ins) = INS1(L"LIST",
                        INS1(L"LITERAL", (yyvsp[0].v)));
                }
#line 2035 "y.tab.c"
    break;

  case 30:
#line 278 "mpsl.y"
                            {
                    /* comma-separated list of symbols */
                    (yyval.ins) = INS2(L"LIST",
                        INS1(L"LITERAL", (yyvsp[0].v)), (yyvsp[-2].ins));
                }
#line 2045 "y.tab.c"
    break;

  case 31:
#line 286 "mpsl.y"
                    {
                (yyval.ins) = INS2(L"OBJECT", (yyvsp[-2].ins), (yyvsp[0].ins));
                }
#line 2053 "y.tab.c"
    break;

  case 32:
#line 289 "mpsl.y"
                      {
                (yyval.ins) = INS2(L"OBJECT", INS1(L"LITERAL", (yyvsp[-2].v)), (yyvsp[0].ins));
                }
#line 2061 "y.tab.c"
    break;

  case 33:
#line 293 "mpsl.y"
                {
                    /* build hash from list of
                       instructions */
                    (yyval.ins) = INS3(L"OBJECT", (yyvsp[-2].ins), (yyvsp[0].ins), (yyvsp[-4].ins));
                }
#line 2071 "y.tab.c"
    break;

  case 34:
#line 299 "mpsl.y"
                {
                    /* build hash from list of
                       instructions */
                    (yyval.ins) = INS3(L"OBJECT", INS1(L"LITERAL", (yyvsp[-2].v)), (yyvsp[0].ins), (yyvsp[-4].ins));
                }
#line 2081 "y.tab.c"
    break;

  case 35:
#line 307 "mpsl.y"
                    {
                    (yyval.ins) = INS1(L"LIST",
                        INS1(L"LITERAL", (yyvsp[0].v)));
                }
#line 2090 "y.tab.c"
    break;

  case 36:
#line 311 "mpsl.y"
                            {
                    /* a.5 compound symbol */
                    (yyval.ins) = INS2(L"LIST",
                        INS1(L"LITERAL", (yyvsp[0].v)), (yyvsp[-2].ins));
                }
#line 2100 "y.tab.c"
    break;

  case 37:
#line 316 "mpsl.y"
                            {
                    /* a.b compound symbol */
                    (yyval.ins) = INS2(L"LIST",
                        INS1(L"LITERAL", (yyvsp[0].v)), (yyvsp[-2].ins));
                }
#line 2110 "y.tab.c"
    break;

  case 38:
#line 321 "mpsl.y"
                            {
                    /* a["b"] or a[5] compound symbol */
                    (yyval.ins) = INS2(L"LIST", (yyvsp[-1].ins), (yyvsp[-3].ins));
                }
#line 2119 "y.tab.c"
    break;

  case 39:
#line 328 "mpsl.y"
                    {
                    /* literal integer */
                    (yyval.ins) = INS1(L"LITERAL", (yyvsp[0].v));
                }
#line 2128 "y.tab.c"
    break;

  case 40:
#line 332 "mpsl.y"
                    {
                    /* literal string */
                    (yyval.ins) = INS1(L"LITERAL", (yyvsp[0].v));
                }
#line 2137 "y.tab.c"
    break;

  case 41:
#line 336 "mpsl.y"
                    {
                    /* literal real number */
                    (yyval.ins) = INS1(L"LITERAL", (yyvsp[0].v));
                }
#line 2146 "y.tab.c"
    break;

  case 42:
#line 340 "mpsl.y"
                    {
                    /* compound symbol */
                    (yyval.ins) = INS1(L"SYMVAL", (yyvsp[0].ins));
                }
#line 2155 "y.tab.c"
    break;

  case 43:
#line 344 "mpsl.y"
                    {
                    /* NULL value */
                    (yyval.ins) = INS1(L"LITERAL", NULL);
                }
#line 2164 "y.tab.c"
    break;

  case 44:
#line 348 "mpsl.y"
                  {
                    /* compiler version */
                    (yyval.ins) = INS1(L"LITERAL", MPDM_S(L"c-mpsl " COMPILER_VERSION));
                }
#line 2173 "y.tab.c"
    break;

  case 45:
#line 353 "mpsl.y"
                            {
                    /* unary minus */
                    (yyval.ins) = INS2(L"MUL", (yyvsp[0].ins), INS1(L"LITERAL", MPDM_R(-1)));
                }
#line 2182 "y.tab.c"
    break;

  case 46:
#line 359 "mpsl.y"
                        { (yyval.ins) = INS2(L"ADD", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2188 "y.tab.c"
    break;

  case 47:
#line 360 "mpsl.y"
                        { (yyval.ins) = INS2(L"SUB", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2194 "y.tab.c"
    break;

  case 48:
#line 361 "mpsl.y"
                        { (yyval.ins) = INS2(L"MUL", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2200 "y.tab.c"
    break;

  case 49:
#line 362 "mpsl.y"
                        { (yyval.ins) = INS2(L"DIV", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2206 "y.tab.c"
    break;

  case 50:
#line 363 "mpsl.y"
                        { (yyval.ins) = INS2(L"MOD", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2212 "y.tab.c"
    break;

  case 51:
#line 365 "mpsl.y"
                        { (yyval.ins) = INS2(L"FMT", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2218 "y.tab.c"
    break;

  case 52:
#line 368 "mpsl.y"
                        { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
                    INS2(L"ADD",
                        INS1(L"SYMVAL", (yyvsp[-2].ins)),
                        (yyvsp[0].ins))
                    );
                }
#line 2229 "y.tab.c"
    break;

  case 53:
#line 374 "mpsl.y"
                        { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
                    INS2(L"SUB",
                        INS1(L"SYMVAL", (yyvsp[-2].ins)),
                        (yyvsp[0].ins))
                    );
                }
#line 2240 "y.tab.c"
    break;

  case 54:
#line 380 "mpsl.y"
                        { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
                    INS2(L"MUL",
                        INS1(L"SYMVAL", (yyvsp[-2].ins)),
                        (yyvsp[0].ins))
                    );
                }
#line 2251 "y.tab.c"
    break;

  case 55:
#line 386 "mpsl.y"
                        { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
                    INS2(L"DIV",
                        INS1(L"SYMVAL", (yyvsp[-2].ins)),
                        (yyvsp[0].ins))
                    );
                }
#line 2262 "y.tab.c"
    break;

  case 56:
#line 392 "mpsl.y"
                        { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
                    INS2(L"MOD",
                        INS1(L"SYMVAL", (yyvsp[-2].ins)),
                        (yyvsp[0].ins))
                    );
                }
#line 2273 "y.tab.c"
    break;

  case 57:
#line 399 "mpsl.y"
                            { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
                    INS2(L"OR",
                        INS1(L"SYMVAL", (yyvsp[-2].ins)),
                        (yyvsp[0].ins))
                    );
                }
#line 2284 "y.tab.c"
    break;

  case 58:
#line 406 "mpsl.y"
                    {
                    /* boolean not */
                    (yyval.ins) = INS1(L"NOT", (yyvsp[0].ins));
                }
#line 2293 "y.tab.c"
    break;

  case 59:
#line 410 "mpsl.y"
                        {
                    /* bool less than */
                    (yyval.ins) = INS2(L"LT", (yyvsp[-2].ins), (yyvsp[0].ins));
                }
#line 2302 "y.tab.c"
    break;

  case 60:
#line 414 "mpsl.y"
                        {
                    /* bool greater than */
                    (yyval.ins) = INS2(L"GT", (yyvsp[-2].ins), (yyvsp[0].ins));
                }
#line 2311 "y.tab.c"
    break;

  case 61:
#line 418 "mpsl.y"
                     {
                    /* bool less or equal than */
                    (yyval.ins) = INS2(L"LE", (yyvsp[-2].ins), (yyvsp[0].ins));
                }
#line 2320 "y.tab.c"
    break;

  case 62:
#line 422 "mpsl.y"
                     {
                    /* bool greater or equal than */
                    (yyval.ins) = INS2(L"GE", (yyvsp[-2].ins), (yyvsp[0].ins));
                }
#line 2329 "y.tab.c"
    break;

  case 63:
#line 426 "mpsl.y"
                         {
                    /* bool equal */
                    (yyval.ins) = INS2(L"EQ", (yyvsp[-2].ins), (yyvsp[0].ins));
                }
#line 2338 "y.tab.c"
    break;

  case 64:
#line 430 "mpsl.y"
                     {
                    /* bool non-equal */
                    (yyval.ins) = INS1(L"NOT",
                        INS2(L"EQ", (yyvsp[-2].ins), (yyvsp[0].ins)));
                }
#line 2348 "y.tab.c"
    break;

  case 65:
#line 436 "mpsl.y"
                    {
                    /* boolean and */
                    (yyval.ins) = INS2(L"AND", (yyvsp[-2].ins), (yyvsp[0].ins));
                }
#line 2357 "y.tab.c"
    break;

  case 66:
#line 440 "mpsl.y"
                    {
                    /* boolean or */
                    (yyval.ins) = INS2(L"OR", (yyvsp[-2].ins), (yyvsp[0].ins));
                }
#line 2366 "y.tab.c"
    break;

  case 67:
#line 445 "mpsl.y"
                            {
                    /* anonymous subroutine (without args) */
                    (yyval.ins) = INS1(L"LITERAL", mpsl_x((yyvsp[-1].ins), NULL, 0));
                }
#line 2375 "y.tab.c"
    break;

  case 68:
#line 451 "mpsl.y"
                {
                    /* anonymous subroutine (with args) */
                    (yyval.ins) = INS1(L"LITERAL", mpsl_x((yyvsp[-1].ins), (yyvsp[-4].ins), 0));
                }
#line 2384 "y.tab.c"
    break;

  case 69:
#line 456 "mpsl.y"
                        {
                    /* parenthesized expression */
                    (yyval.ins) = (yyvsp[-1].ins);
                }
#line 2393 "y.tab.c"
    break;

  case 70:
#line 461 "mpsl.y"
                    {
                    /* empty list */
                    (yyval.ins) = INS1(L"LITERAL", MPDM_A(0));
                }
#line 2402 "y.tab.c"
    break;

  case 71:
#line 465 "mpsl.y"
                        {
                    /* non-empty list */
                    (yyval.ins) = (yyvsp[-1].ins);
                }
#line 2411 "y.tab.c"
    break;

  case 72:
#line 470 "mpsl.y"
                    {
                    /* empty hash */
                    (yyval.ins) = INS1(L"LITERAL", MPDM_O());
                }
#line 2420 "y.tab.c"
    break;

  case 73:
#line 474 "mpsl.y"
                        {
                    /* non-empty hash */
                    (yyval.ins) = (yyvsp[-1].ins);
                }
#line 2429 "y.tab.c"
    break;

  case 74:
#line 479 "mpsl.y"
                        {
                    /* function call (without args) */
                    (yyval.ins) = INS2(L"EXECSYM", (yyvsp[-2].ins), code_pos());
                }
#line 2438 "y.tab.c"
    break;

  case 75:
#line 483 "mpsl.y"
                            {
                    /* function call (with args) */
                    (yyval.ins) = INS3(L"EXECSYM", (yyvsp[-3].ins), code_pos(), (yyvsp[-1].ins));
                }
#line 2447 "y.tab.c"
    break;

  case 76:
#line 487 "mpsl.y"
                                   {
                    /* function call with only an inverse argument */
                    (yyval.ins) = INS3(L"METHOD", (yyvsp[-2].ins), code_pos(), INS1(L"ILIST", (yyvsp[-4].ins)));
                }
#line 2456 "y.tab.c"
    break;

  case 77:
#line 491 "mpsl.y"
                                        {
                    /* function call with inverse argument and other ones */
                    (yyval.ins) = INS3(L"METHOD", (yyvsp[-3].ins), code_pos(), INS2(L"ILIST", (yyvsp[-5].ins), (yyvsp[-1].ins)));
                }
#line 2465 "y.tab.c"
    break;

  case 78:
#line 495 "mpsl.y"
                        {
                    /* simple assignation */
                    (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins), (yyvsp[0].ins));
                }
#line 2474 "y.tab.c"
    break;


#line 2478 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[+*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 502 "mpsl.y"


void yyerror(char *s)
{
    char tmp[1024];

    snprintf(tmp, sizeof(tmp), ":%d: %s", mpsl_line + 1, s);

    mpsl_error(mpdm_strcat(mpsl_source, MPDM_MBS(tmp)));
}


static mpdm_t mpsl_c_compiler(mpdm_t code, mpdm_t source)
/* the classical (lex+yacc) compiler entry point */
{
    mpdm_t v;
    mpdm_t x = NULL;

    mpdm_ref(code);

    /* first line */
    mpsl_line = 0;

    /* reset last bytecode */
    mpsl_bytecode = NULL;

    /* set globals */
    if (mpdm_type(code) == MPDM_TYPE_FILE) {
        mpsl_next_char = NULL;
        mpsl_file      = mpdm_get_filehandle(code);
    }
    else {
        mpsl_next_char = (wchar_t *)code->data;
        mpsl_file      = NULL;
    }

    mpdm_store(&mpsl_source, source);

    /* cache some values */
    v = mpdm_get_wcs(mpdm_root(), L"MPSL");
    mpsl_lc = mpdm_get_wcs(v, L"LC");

    /* compile! */
    if (yyparse() == 0 && mpsl_bytecode != NULL)
        x = mpsl_x(mpsl_bytecode, NULL, 1);

    /* clean back cached values */
    mpsl_lc = NULL;

    mpdm_store(&mpsl_source, NULL);

    mpdm_unref(code);

    return x;
}


mpdm_t mpsl_c_compiler_x(mpdm_t args, mpdm_t ctxt)
{
    return mpsl_c_compiler(mpdm_get_i(args, 0), mpdm_get_i(args, 1));
}
